<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/pl1_code_changes.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>04/18/80  Potentially incompatible code changes generated by the PL/I compiler
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>Since the Multics PL/I compiler was written, it has had a bug which may cause
<span id="L4" class="LineNr">  4 </span>two external procedures to communicate incorrectly via parameters, based
<span id="L5" class="LineNr">  5 </span>variables or external static variables.  This is PL/I bug number 1186, known
<span id="L6" class="LineNr">  6 </span>informally as the padded reference bug.  This bug involves the conventions
<span id="L7" class="LineNr">  7 </span>that two external procedures use to communicate, and hence cannot be fixed
<span id="L8" class="LineNr">  8 </span>without recompiling every program at every Multics site.
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>Release 26 of the Multics PL/I compiler implements the first phase of fixing
<span id="L11" class="LineNr"> 11 </span>this bug.  The second phase will be completed in about two years.  Users will
<span id="L12" class="LineNr"> 12 </span>have to recompile every program with release 26 or later before the second
<span id="L13" class="LineNr"> 13 </span>phase is installed.
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>Some programs with invalid PL/I that worked with release 25 or earlier will
<span id="L16" class="LineNr"> 16 </span>fail when compiled with release 26 or later.  There shouldn't be too many
<span id="L17" class="LineNr"> 17 </span>programs that fail.  Programs that misdeclare an entry will fail if there is a
<span id="L18" class="LineNr"> 18 </span>mismatch in the alignment attribute for short bit string or short character
<span id="L19" class="LineNr"> 19 </span>string parameters or return values.  Short means two words or less.
<span id="L20" class="LineNr"> 20 </span>
<span id="L21" class="LineNr"> 21 </span>The rest of this info seg describes what the padded reference bug is, and
<span id="L22" class="LineNr"> 22 </span>exactly what code sequences are changing.
<span id="L23" class="LineNr"> 23 </span>
<span id="L24" class="LineNr"> 24 </span>
<span id="L25" class="LineNr"> 25 </span>Padded references: Some short bit strings or short character strings are
<span id="L26" class="LineNr"> 26 </span>padded.  Short means two words or less, i.e.  for character strings, 8
<span id="L27" class="LineNr"> 27 </span>characters or less, and for bit strings, 72 bits or less.  Some short
<span id="L28" class="LineNr"> 28 </span>character strings or bit strings have unused bits in a word.  For example:
<span id="L29" class="LineNr"> 29 </span>
<span id="L30" class="LineNr"> 30 </span>          dcl v bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> aligned;
<span id="L31" class="LineNr"> 31 </span>          dcl w bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>;
<span id="L32" class="LineNr"> 32 </span>
<span id="L33" class="LineNr"> 33 </span>One word of storage will be used for v.  The first bit will be the value of v
<span id="L34" class="LineNr"> 34 </span>and the remaining bits will be zero.
<span id="L35" class="LineNr"> 35 </span>
<span id="L36" class="LineNr"> 36 </span>            0  1                 35
<span id="L37" class="LineNr"> 37 </span>          --------------------------
<span id="L38" class="LineNr"> 38 </span>          | v | pad - must be zero |
<span id="L39" class="LineNr"> 39 </span>          --------------------------
<span id="L40" class="LineNr"> 40 </span>
<span id="L41" class="LineNr"> 41 </span>The variable w, since it is unaligned, only needs one bit for its value.
<span id="L42" class="LineNr"> 42 </span>
<span id="L43" class="LineNr"> 43 </span>            0
<span id="L44" class="LineNr"> 44 </span>          -----
<span id="L45" class="LineNr"> 45 </span>          | w |
<span id="L46" class="LineNr"> 46 </span>          -----
<span id="L47" class="LineNr"> 47 </span>
<span id="L48" class="LineNr"> 48 </span>The compiler will try to pad w, as in v, if it is not a member of a structure,
<span id="L49" class="LineNr"> 49 </span>if it is automatic and if it the variable is only referred to by one name
<span id="L50" class="LineNr"> 50 </span><span class="textRainbow_lv0_p0">(</span>This checking is not done correctly<span class="textRainbow_lv0_p0">)</span>.  Variables may be padded even if they
<span id="L51" class="LineNr"> 51 </span>are declared unaligned.  The bit string b in the following structure won't be
<span id="L52" class="LineNr"> 52 </span>padded since there is another variable declared to use the remaining part of
<span id="L53" class="LineNr"> 53 </span>the word.
<span id="L54" class="LineNr"> 54 </span>
<span id="L55" class="LineNr"> 55 </span>          dcl 1 s unaligned,
<span id="L56" class="LineNr"> 56 </span>                2 b bit <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span>,
<span id="L57" class="LineNr"> 57 </span>                2 c bit <span class="textRainbow_lv0_p0">(</span>34<span class="textRainbow_lv0_p0">)</span>;
<span id="L58" class="LineNr"> 58 </span>
<span id="L59" class="LineNr"> 59 </span>The compiler could generate better code if it used the unused bits in the
<span id="L60" class="LineNr"> 60 </span>word.  That way it could use word oriented instructions directly, such as lda
<span id="L61" class="LineNr"> 61 </span>or ldaq, instead of masking the unused bits.  Often, such as with unaligned
<span id="L62" class="LineNr"> 62 </span>parameters, exactly which bits are unused is not known until runtime.  A
<span id="L63" class="LineNr"> 63 </span>reference to a short string is called a &quot;padded reference&quot; if the unused bits
<span id="L64" class="LineNr"> 64 </span>in the word are used.  When a padded reference is stored, the pad bits are
<span id="L65" class="LineNr"> 65 </span>zeroed.  When a padded reference is fetched, the unused bits are assumed to be
<span id="L66" class="LineNr"> 66 </span>zero.  In order for this to work, references to a short string must either be
<span id="L67" class="LineNr"> 67 </span>all padded or all unpadded.  This is easy to determine if the reference is
<span id="L68" class="LineNr"> 68 </span>only used within one external procedure.  If the reference is used by more
<span id="L69" class="LineNr"> 69 </span>than one external procedure, for example, if it is passed as an argument by
<span id="L70" class="LineNr"> 70 </span>reference, then the compiler must ensure that all references in any external
<span id="L71" class="LineNr"> 71 </span>procedure are either all padded or all unpadded.
<span id="L72" class="LineNr"> 72 </span>
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>The padded reference bug: Sometimes the compiler pads some references to a
<span id="L75" class="LineNr"> 75 </span>variable, and inconsistently at other times, uses unpadded references to the
<span id="L76" class="LineNr"> 76 </span>variable.  For example:
<span id="L77" class="LineNr"> 77 </span>
<span id="L78" class="LineNr"> 78 </span>          dcl c char <span class="textRainbow_lv0_p0">(</span>5<span class="textRainbow_lv0_p0">)</span>;
<span id="L79" class="LineNr"> 79 </span>          dcl cb char <span class="textRainbow_lv0_p0">(</span>5<span class="textRainbow_lv0_p0">)</span> based <span class="textRainbow_lv0_p0">(</span>addr <span class="textRainbow_lv1_p0">(</span>c<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L80" class="LineNr"> 80 </span>
<span id="L81" class="LineNr"> 81 </span>References to c are padded while references to cb are not.  The program will
<span id="L82" class="LineNr"> 82 </span>fail if c is always set by refering to cb, and always read by refering to c.
<span id="L83" class="LineNr"> 83 </span>If a string can be padded and is passed as an argument in a program, then set
<span id="L84" class="LineNr"> 84 </span>references to that string are not padded.  However, if the called program does
<span id="L85" class="LineNr"> 85 </span>not pass the string as an argument, the called program's references are
<span id="L86" class="LineNr"> 86 </span>padded.  Communication will fail if the calling program sets the string and
<span id="L87" class="LineNr"> 87 </span>the called program reads the string.  The calling program won't pad the
<span id="L88" class="LineNr"> 88 </span>string, but the called program will assume the string was padded when it was
<span id="L89" class="LineNr"> 89 </span>set.
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>
<span id="L92" class="LineNr"> 92 </span>Release 26 code changes: The padded reference bug will be fixed in two phases.
<span id="L93" class="LineNr"> 93 </span>The first phase is done in release 26.  All set references that should be
<span id="L94" class="LineNr"> 94 </span>padded will be padded.  More set references will be padded in release 26 than
<span id="L95" class="LineNr"> 95 </span>in previous releases.  The second phase is to correctly pad read references.
<span id="L96" class="LineNr"> 96 </span>This phase will be done in about two years.  Since the effect of the first
<span id="L97" class="LineNr"> 97 </span>phase is to pad more references, it is a compatible change.  The second phase
<span id="L98" class="LineNr"> 98 </span>will assume that references are padded according to the release 26
<span id="L99" class="LineNr"> 99 </span>conventions.  All programs should be recompiled with the release 26 compiler,
<span id="L100" class="LineNr">100 </span>or a later compiler, before the compiler implementing the second phase is
<span id="L101" class="LineNr">101 </span>installed.  Note that most symptoms of the padded reference bug will disappear
<span id="L102" class="LineNr">102 </span>once programs are recompiled with the release 26 compiler.
<span id="L103" class="LineNr">103 </span>
<span id="L104" class="LineNr">104 </span>One of the contexts in which release 26 will pad references is short, aligned,
<span id="L105" class="LineNr">105 </span>string parameters or return values.  For example, a program calls the
<span id="L106" class="LineNr">106 </span>following procedure:
<span id="L107" class="LineNr">107 </span>
<span id="L108" class="LineNr">108 </span> called_proc:
<span id="L109" class="LineNr">109 </span>     procedure <span class="textRainbow_lv0_p0">(</span>short_cs<span class="textRainbow_lv0_o0">,</span> short_bs<span class="textRainbow_lv0_p0">)</span>;
<span id="L110" class="LineNr">110 </span>          dcl short_cs char <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> aligned;
<span id="L111" class="LineNr">111 </span>          dcl short_bs bit <span class="textRainbow_lv0_p0">(</span>5<span class="textRainbow_lv0_p0">)</span> aligned;
<span id="L112" class="LineNr">112 </span>
<span id="L113" class="LineNr">113 </span>          short_cs = &quot;ab&quot;;
<span id="L114" class="LineNr">114 </span>          short_bs = &quot;&quot;b;
<span id="L115" class="LineNr">115 </span>     end called_proc;
<span id="L116" class="LineNr">116 </span>
<span id="L117" class="LineNr">117 </span>The release 25 compiler generates the following code:
<span id="L118" class="LineNr">118 </span>
<span id="L119" class="LineNr">119 </span>          short_cs = &quot;ab&quot;;
<span id="L120" class="LineNr">120 </span>
<span id="L121" class="LineNr">121 </span>                    lda       49762,du
<span id="L122" class="LineNr">122 </span>                    epp7      pr6|26,*
<span id="L123" class="LineNr">123 </span>                    epp5      pr7|2,*             short_cs
<span id="L124" class="LineNr">124 </span>                    stba      pr5|0,60            short_cs
<span id="L125" class="LineNr">125 </span>
<span id="L126" class="LineNr">126 </span>          short_bs = &quot;&quot;b;
<span id="L127" class="LineNr">127 </span>
<span id="L128" class="LineNr">128 </span>                    lda       3,ic                000022 = 017777777777
<span id="L129" class="LineNr">129 </span>                    ansa      pr7|4,*             short_bs
<span id="L130" class="LineNr">130 </span>
<span id="L131" class="LineNr">131 </span>Note that the unused bits are not padded.  The release 26 compiler pads these
<span id="L132" class="LineNr">132 </span>references.  It generates:
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span>          short_cs = &quot;ab&quot;;
<span id="L135" class="LineNr">135 </span>
<span id="L136" class="LineNr">136 </span>                    lda       49762,du
<span id="L137" class="LineNr">137 </span>                    epp7      pr6|26,*
<span id="L138" class="LineNr">138 </span>                    sta       pr7|2,*             short_cs
<span id="L139" class="LineNr">139 </span>
<span id="L140" class="LineNr">140 </span>          short_bs = &quot;&quot;b;
<span id="L141" class="LineNr">141 </span>
<span id="L142" class="LineNr">142 </span>                    stz       pr7|4,*             short_bs
<span id="L143" class="LineNr">143 </span>
<span id="L144" class="LineNr">144 </span>The compiler can pad these references since the strings are aligned.  This is
<span id="L145" class="LineNr">145 </span>a compatible change for valid PL/I programs.  However, certain invalid PL/I
<span id="L146" class="LineNr">146 </span>programs will fail.  For example:
<span id="L147" class="LineNr">147 </span>
<span id="L148" class="LineNr">148 </span> calling_proc:
<span id="L149" class="LineNr">149 </span>     procedure;
<span id="L150" class="LineNr">150 </span>          dcl called_proc entry <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit <span class="textRainbow_lv1_p0">(</span>5<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;        /* Invalid */
<span id="L151" class="LineNr">151 </span>          dcl 1 s,
<span id="L152" class="LineNr">152 </span>                2 cs char <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span>,
<span id="L153" class="LineNr">153 </span>                2 x char <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> init <span class="textRainbow_lv0_p0">(</span>&quot;cd&quot;<span class="textRainbow_lv0_p0">)</span>;
<span id="L154" class="LineNr">154 </span>          dcl 1 t,
<span id="L155" class="LineNr">155 </span>                2 bs bit <span class="textRainbow_lv0_p0">(</span>5<span class="textRainbow_lv0_p0">)</span>,
<span id="L156" class="LineNr">156 </span>                2 y bit <span class="textRainbow_lv0_p0">(</span>31<span class="textRainbow_lv0_p0">)</span> init <span class="textRainbow_lv0_p0">(</span><span class="textRainbow_lv1_p0">(</span>31<span class="textRainbow_lv1_p0">)</span>&quot;1&quot;b<span class="textRainbow_lv0_p0">)</span>;
<span id="L157" class="LineNr">157 </span>
<span id="L158" class="LineNr">158 </span>          call called_proc <span class="textRainbow_lv0_p0">(</span>s.cs<span class="textRainbow_lv0_o0">,</span> t.bs<span class="textRainbow_lv0_p0">)</span>;
<span id="L159" class="LineNr">159 </span>
<span id="L160" class="LineNr">160 </span>          ...
<span id="L161" class="LineNr">161 </span>
<span id="L162" class="LineNr">162 </span>     end calling_proc;
<span id="L163" class="LineNr">163 </span>
<span id="L164" class="LineNr">164 </span>Note that calling_proc has misdeclared called_proc to have unaligned short
<span id="L165" class="LineNr">165 </span>string parameters instead of aligned short string parameters.  The values of
<span id="L166" class="LineNr">166 </span>s.x and t.y won't change if called_proc is compiled with release 25.  However,
<span id="L167" class="LineNr">167 </span>once called_proc is compiled with release 26, the values of s.x and t.y will
<span id="L168" class="LineNr">168 </span>be obliterated.  The affected programs misdeclare an entry so there is a
<span id="L169" class="LineNr">169 </span>mismatch in the alignment attribute for short bit string or short character
<span id="L170" class="LineNr">170 </span>string parameters or return values.  This change should not affect too many
<span id="L171" class="LineNr">171 </span>programs.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
